;----------------------------------------------------------------------------------------
; DOMXML Writer-Parser 
;
; Copyright 2007 Veria Kalantary - Ideas of East Company
; http://www.IdeasofEast.com; http://www.ioe.co.ir
;
;----------------------------------------------------------------------------------------

include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\advapi32.inc
include \masm32\include\oleaut32.inc
include \masm32\include\ole32.inc
include \masm32\include\oaidl.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib

include Public.inc
include IoEMacros.inc
include XMLDocument.inc
include ShowXML.inc
  	
;	//	CUseXMLObj Object Definition
Object CUseXMLObj, ,SdiApp 
	RedefineMethod		Init
	RedefineMethod    	Done
	StaticMethod		Clear
    Private	
	StaticMethod		FinalExceptionHandler, 	DWORD
	StaticMethod      	OnCreate,     			DWORD, DWORD
	
	Event     			OnCreate,     WM_CREATE
	   	
  	Embed				RootNode, 				CXMLNode    
    Embed				WriteXMLDocument,		CXMLDocument
    Embed				ReadXMLDocument, 		CXMLDocument		
ObjectEnd

;	//	CUseXMLObj Object Implementation
Method CUseXMLObj.FinalExceptionHandler, uses esi edi ebx, lpException:DWORD
;ClearUp	
	mov eax, 0
MethodEnd

Method CUseXMLObj.Init, uses esi
	LOCAL icex: INITCOMMONCONTROLSEX
	LOCAL wc:WNDCLASSEX
						
	SetObject esi
	invoke InitCommonControls 
	mov icex.dwSize, sizeof INITCOMMONCONTROLSEX
	mov	icex.dwICC, ICC_DATE_CLASSES or ICC_USEREX_CLASSES or ICC_INTERNET_CLASSES\
				 or ICC_ANIMATE_CLASS or ICC_HOTKEY_CLASS or ICC_PAGESCROLLER_CLASS\
				 or ICC_COOL_CLASSES
	invoke InitCommonControlsEx, addr icex	
	
	mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW
	m2m wc.lpfnWndProc, $MethodAddr(CUseXMLObj.WndProc)
	mov wc.cbClsExtra, NULL
	mov wc.cbWndExtra, NULL
	push hInstance
	pop wc.hInstance
	mov wc.hbrBackground, COLOR_BTNFACE + 1
	mov wc.lpszMenuName, NULL
	mov wc.lpszClassName, OFFSET szClassName
	
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov wc.hIcon, eax
	mov wc.hIconSm, eax
	
	invoke LoadCursor, NULL, IDC_ARROW
	mov wc.hCursor, eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx, NULL, ADDR szClassName, ADDR szAppTitle,\
           WS_OVERLAPPEDWINDOW,\
           CW_USEDEFAULT, CW_USEDEFAULT, 225, 450,\
           NULL, NULL, hInstance, esi
									
	invoke ShowWindow, [esi].hWnd, SW_SHOWNORMAL
	invoke UpdateWindow, [esi].hWnd		
MethodEnd    

Method CUseXMLObj.Done, uses esi 	
	SetObject esi		
	OCall [esi].WriteXMLDocument::CXMLDocument.Done
	OCall [esi].ReadXMLDocument::CXMLDocument.Done
	OCall [esi].RootNode::CXMLNode.Done
	invoke CoUninitialize 
MethodEnd

Method CUseXMLObj.OnCreate, uses esi, wParam:dword, lParam:dword
	LOCAL TempNode: CXMLNode
	SetObject esi
	invoke CoInitialize, NULL
	invoke SetUnhandledExceptionFilter, $MethodAddr(esi::CUseXMLObj.FinalExceptionHandler)
	invoke CreateWindowEx, 0, StrM("SysTreeView32"), 0,\
				WS_CHILD or WS_VISIBLE or TVS_HASLINES or TVS_HASBUTTONS or TVS_LINESATROOT,\
				10, 10, 200, 400, [esi].hWnd, 0, hInstance, 0								
	mov	hTreeView, eax
	invoke SetWindowLong, hTreeView, GWL_WNDPROC, TreeViewProc
	mov	OldTreeViewProc, eax		
	OCall [esi].WriteXMLDocument::CXMLDocument.Init
	OCall [esi].ReadXMLDocument::CXMLDocument.Init
	OCall [esi].RootNode::CXMLNode.Init
	LNew TempNode, CXMLNode
	OCall TempNode::CXMLNode.Init
	OCall [esi].WriteXMLDocument::CXMLDocument.AddChild, StrM("Root")
	OCall [esi].RootNode::CXMLNode.SetNode, eax
	OCall [esi].RootNode::CXMLNode.SetAttribute, StrM("Created"), StrM("Using XML Object")
	OCall [esi].RootNode::CXMLNode.AddChild, StrM("Node1")
	OCall TempNode::CXMLNode.SetNode, eax
	OCall TempNode::CXMLNode.SetText, StrM("Text1")
	OCall [esi].RootNode::CXMLNode.AddChild, StrM("Node2")
	OCall TempNode::CXMLNode.SetNode, eax
	OCall TempNode::CXMLNode.SetText, StrM("Text2")
	OCall [esi].RootNode::CXMLNode.AddChild, StrM("Node3")
	OCall TempNode::CXMLNode.SetNode, eax
	OCall TempNode::CXMLNode.AddChild, StrM("SubNode1")
	OCall TempNode::CXMLNode.AddChild, StrM("SubNode2")
	OCall TempNode::CXMLNode.AddChild, StrM("SubNode3")	
	OCall [esi].WriteXMLDocument::CXMLDocument.SaveToFile, StrM("test.xml")
	OCall [esi].WriteXMLDocument::CXMLDocument.GetXML
	push eax
	invoke MessageBox, 0, eax, 0, MB_OK
	pop eax
	push eax
	OCall [esi].ReadXMLDocument::CXMLDocument.SetXML, eax
	call GlobalFree	 
	invoke AddTreeViewNode, hTreeView, NULL, TVI_ROOT, StrM("XML Document")
	mov hRoot, eax
	OCall [esi].ReadXMLDocument::CXMLDocument.GetDocumentElement
	OCall TempNode::CXMLNode.SetNode, eax						
	invoke ParseXML, hTreeView, addr TempNode, hRoot
	invoke SendMessage, hTreeView, TVM_EXPAND, TVE_EXPAND, hRoot 		
MethodEnd

Method CUseXMLObj.Clear, uses esi
	SetObject esi
	OCall [esi].WriteXMLDocument::CXMLDocument.Clear
	OCall [esi].ReadXMLDocument::CXMLDocument.Clear	
MethodEnd