;----------------------------------------------------------------------------------------
; ShowXML Masm32 Library 
;
; Copyright 2007 Veria Kalantary - Ideas of East Company
; http://www.IdeasofEast.com; http://www.ioe.co.ir
;
;----------------------------------------------------------------------------------------

TreeViewProc						proto :HWND, :UINT, :WPARAM, :LPARAM
AddTreeViewNode						proto :HWND, :DWORD, :DWORD, :DWORD
ParseXML							proto :HWND, :PXMLNode, :HTREEITEM 

CStr	szAppTitle,  "Using DOMXML Object in MASM32"

.data
   	szClassName						db "MainWinClass", 0
	szElement						db "element", 0	
	szText							db "text", 0										

.data?
	hTreeView						DWORD	?
	OldTreeViewProc					DWORD	?
	hRoot							DWORD 	?
	
.code	
TreeViewProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	mov	eax, uMsg
	.if(eax == WM_COMMAND)
	.elseif(eax == WM_LBUTTONDOWN)
	.elseif(eax == WM_LBUTTONUP)
	.elseif(eax == WM_LBUTTONDBLCLK)
	.elseif(eax == WM_RBUTTONDOWN)
	.endif
	invoke CallWindowProc, OldTreeViewProc, hWin, uMsg, wParam, lParam
	ret
TreeViewProc endp

AddTreeViewNode proc hWnd:HWND, hParentItem:DWORD, hInsertAfter:DWORD, pszText:DWORD
	LOCAL tvins: TV_INSERTSTRUCT

	m2m	tvins.hParent, hParentItem
	m2m	tvins.hInsertAfter, hInsertAfter	
	mov	tvins.item._mask, TVIF_TEXT
	m2m	tvins.item.pszText, pszText
	invoke SendMessage, hWnd, TVM_INSERTITEM, 0, addr tvins			
	ret
AddTreeViewNode endp

ParseXML proc hWnd:HWND, InitNode:PXMLNode, ht:HTREEITEM	 
	LOCAL ChildNode: CXMLNode	
	LOCAL i: DWORD
	LOCAL iMax: DWORD
	LOCAL ht2: HTREEITEM
		
	OCall InitNode::CXMLNode.GetType											
	invoke lstrcmp, eax, addr szElement	
	push eax
    .if eax == 0
    	OCall InitNode::CXMLNode.GetName
    	push eax    				
		invoke AddTreeViewNode, hWnd, ht, TVI_LAST, eax
		mov ht2, eax				
	.else		
		OCall InitNode::CXMLNode.GetType
		push eax	
		invoke lstrcmp, eax, addr szText
		.if eax == 0			
			OCall InitNode::CXMLNode.GetText			
			push eax			
			invoke AddTreeViewNode, hWnd, ht, TVI_LAST, eax
			mov ht2, eax												
		.else		
			OCall InitNode::CXMLNode.GetName
    		push eax    				
			invoke AddTreeViewNode, hWnd, ht, TVI_LAST, eax			
			mov ht2, eax																	
		.endif	
		call GlobalFree	
	.endif	
	call GlobalFree 
	call GlobalFree			
	OCall InitNode::CXMLNode.HasChildNodes
	.if eax
		OCall InitNode::CXMLNode.GetChildNodesCount								  		
		mov iMax, eax		 
		mov i, 0		
		LNew ChildNode, CXMLNode
		OCall ChildNode::CXMLNode.Init
		.while TRUE					
			OCall InitNode::CXMLNode.GetChildNode, i
			OCall ChildNode::CXMLNode.SetNode, eax																		
			invoke ParseXML, hWnd, addr ChildNode, ht2
			inc i
			mov ebx, iMax
			cmp i, ebx
			je Exit
		.endw		
	.endif
Exit:		
    ret
ParseXML endp
